/**
 * Noiz
 * (c) Kenta Cho (cs8k-cyu@asahi-net.or.jp)
 * http://www.asahi-net.or.jp/~cs8k-cyu/
 *
 * noiz.c(main routine)
 */

#include <nds.h>
#include "noiz.h"

#include "sincos.h"
#include "displaymanager.h"
#include "gamemanager.h"

static int StartApplication(void) {
  Boolean exist = 0;
//  autoOffTime = SysSetAutoOffTime(0);
  randomize();
  createScreenBuffer();
  loadBitmaps();
//  exist = PrefGetAppPreferencesV10(NOIZ_CID, 1, &prefData, sizeof(prefData));
  initGame();
  if ( exist ) {
    getPrefData();
  } else {
    resetGameStatus();
  }
}

static void StopApplication(void) {
//  SysSetAutoOffTime(autoOffTime);
  unloadBitmaps();
  setLevelMissData();
//  PrefSetAppPreferencesV10(NOIZ_CID, 1, &prefData, sizeof(prefData));
}

/**
 * event hanlder for title form
 */
 /*
static Boolean TitleFormHandleEvent(EventPtr event) {
  Boolean handled = FALSE;
  switch ( event->eType ) {
  case ctlSelectEvent:
    if ( event->data.ctlEnter.controlID == START_BUTTON ) {
      startButtonPushed();
      handled = TRUE;
    } else if ( event->data.ctlEnter.controlID == RESET_BUTTON ) {
      if ( FrmAlert(RESET_DIALOG) == 0 ) {
	resetGameStatus();
	drawTitle();
      }
      handled = TRUE;
    }
    break;
  case frmOpenEvent:
    FrmDrawForm(FrmGetActiveForm());
    drawTitle();
    handled = TRUE;
    break;
  }
  return handled;
}

*/
// event loop interval
#define INTERVAL 10

static void EventLoop(void) {
  uint16 error;
  long ntc, tc;
  int itv;
  ntc =/* TimGetTicks() +*/ INTERVAL;
  startDrawOffscreen();
  tc = 0;
  startGame();
  do {
//    swiWaitForVBlank();
    tc++;
    if ( tc >= ntc ) {
      if ( gameStatus.status == GAME_IN_PROGRESS ) {
	handleGameStatus();
      }
      //ntc = tc + INTERVAL;
      ntc = ((tc+ntc)>>1) + INTERVAL;
    }
  } while ( 1 );
}

int main(void) {
  StartApplication();
  EventLoop();
  StopApplication();
  return 0;
}
