/**
 * Noiz
 * (c) Kenta Cho (cs8k-cyu@asahi-net.or.jp)
 * http://www.asahi-net.or.jp/~cs8k-cyu/
 *
 * noiz.h(header file)
 */
 
#ifndef __NOIZ_H
#define __NOIZ_H

#include "noiz_rsc.h"
#include "math.h"
#include <nds.h>

#define TRUE 1
#define FALSE 0
#define randomize() math_rand_set_seed(IPC->curtime[7] | (IPC->curtime[6] << 8) | (IPC->curtime[5] << 16) | (IPC->curtime[3] << 24))
#define randN(N) math_rand(N)

#define BULLET_NOT_EXIST -9999

typedef uint8 Boolean;

typedef struct {
  int x, y, mx, my;
} Point;

typedef struct {
  Point point0, point1;
  Point prvPoint0, prvPoint1;
  Boolean vctChk;
} Bullet;

#define CTTYPE_MAX 12
#define HISTORY_NUM 4

typedef struct {
  int level;
  int miss;
} History;

typedef struct {
  int ctTypeQue[2][CTTYPE_MAX];
  int cttqStatus[2];
  int cttqSelect;
  int level;
  int miss;
  int lvlTime;
  History history[HISTORY_NUM];
} PrefData;

typedef struct {
  void (*curtainMaker)(int); 
  int maxRank;
} CurtainType;

typedef struct {
  void (*curtainMaker)(int); 
  int rank;
} Curtain;

#define CURTAIN_MAX 8

typedef struct {
  Curtain curtain[CURTAIN_MAX];
  int curtainNmb;
  int lvlTime;
  int level;
  int miss;
} LevelStatus;

#define TITLE 0
#define GAME_IN_PROGRESS 1

typedef struct {
  int status;
} GameStatus;

#endif
