#include <nds.h>
#include "displaymanager.h"
#include "noiz.h"

void EvtGetPen(int16 *px, int16 *py, Boolean *pd)
{
  *px = IPC->touchXpx;
  *py = IPC->touchYpx;
  *pd = !(IPC->buttons & IPC_PEN_DOWN);
}

/*
void WinDrawLine(int x1, int y1, int x2, int y2)
{
  Boolean steep;
  int tmp;
  int deltax;
  int deltay;
  int error = 0;
  int deltaerr;
  int x;
  int y;
  int xstep, ystep;
  
  deltax = x2 - x1;   
  deltay = y2 - y1;
  deltaerr = deltay;
  
  if (deltax < 0)
    deltax = -deltax;
  if (deltay < 0)
    deltay = -deltay;

  steep = deltay > deltax; 
  if (steep)
  {
    tmp = x1; x1 = y1; y1 = tmp;
	tmp = x2; x2 = y2; y2 = tmp;
  }
  x = x1;
  y = y1;
  
  if (x1 < x2) xstep = 1; else xstep = -1;
  if (y1 < y2) ystep = 1; else ystep = -1;  
  if (steep) plot(y, x, 0xFFFF); else plot(x, y, 0xFFFF);
  
  while(x != x2)
  {
    x += xstep;
	error += deltaerr;
	
	if ((error * 2) > deltax)
	{
	  y += ystep;
	  error -= deltax;
	}
	if (steep) plot(y, x, 0xFFFF); else plot(x, y, 0xFFFF);
  }
}
*/
void WinDrawLine(int x1, int y1, int x2, int y2)
{
	int	dx,		//deltas
        dy,
        dx2,	//scaled deltas
        dy2,
        ix,		//increase rate on the x axis
        iy,		//increase rate on the y axis
        err,	//the error term
        i;		//looping variable

//    printf("%d,%d->%d,%d\n",x1,y1,x2,y2);
	// identify the first pixel
	volatile uint16 *ptr_vid = bmp + x1 + (y1 * 256);

	// difference between starting and ending points
	dx = x2 - x1;
	dy = y2 - y1;

	// calculate direction of the vector and store in ix and iy
	if (dx >= 0)
		ix = 1;

	if (dx < 0)
	{
		ix = -1;
		dx = -dx;
	}

	if (dy >= 0)
		iy = 256;

	if (dy < 0)
	{
		iy = -256;
		dy = -dy;
	}

	// scale deltas and store in dx2 and dy2
	dx2 = dx * 2;
	dy2 = dy * 2;

	if (dx > dy)	// dx is the major axis
	{
		// initialize the error term
		err = dy2 - dx;

		for (i = 0; i <= dx; i++)
		{
			*ptr_vid = 0xFFFF;
			if (err >= 0)
			{
				err -= dx2;
				ptr_vid += iy;
				if ((ptr_vid > (bmp + (SCREEN_HEIGHT * 256))) || (ptr_vid < bmp))
				{
				  return;
				}
			}
			err += dy2;
            if ((((int)(ptr_vid + ix) % 512) - ((int)ptr_vid % 512)) != (ix * 2))
			{
			  return;
			}
			ptr_vid += ix;
		}
	}
	
	else 		// dy is the major axis
	{
		// initialize the error term
		err = dx2 - dy;

		for (i = 0; i <= dy; i++)
		{
			*ptr_vid = 0xFFFF;
			if (err >= 0)
			{
				err -= dy2;
                if ((((int)(ptr_vid + ix) % 512) - ((int)ptr_vid % 512)) != (ix * 2))
				{
					return;
				}
				ptr_vid += ix;
			}
			err += dx2;
			ptr_vid += iy;
			if ((ptr_vid > (bmp + (SCREEN_HEIGHT * 256))) || (ptr_vid < bmp))
			{
				return;
			}
		}
	}
}
